Index: code/trunk/src/core/XMLPort.h
===================================================================
--- code/trunk/src/core/XMLPort.h	(revision 1627)
+++ code/trunk/src/core/XMLPort.h	(revision 1628)
@@ -152,4 +152,6 @@
                                 this->parseResult_ = PR_waiting_for_default_values;
                         }
+                        else
+                            this->parseResult_ = PR_waiting_for_default_values;
                     }
                     catch (ticpp::Exception& ex)
Index: code/trunk/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1627)
+++ code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1628)
@@ -37,5 +37,5 @@
 #include "util/OrxonoxPlatform.h"
 
-#if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC
+#if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && 0
 
 // including std headers here is useless since they're already precompiled
@@ -112,9 +112,9 @@
 #include "network/Synchronisable.h"
 
-#include "tools/Mesh.h"
-#include "tools/Timer.h"
-#include "objects/Model.h"
-#include "objects/Tickable.h"
-#include "objects/WorldEntity.h"
+//#include "tools/Mesh.h"
+//#include "tools/Timer.h"
+//#include "objects/Model.h"
+//#include "objects/Tickable.h"
+//#include "objects/WorldEntity.h"
 
 #endif /* Compiler MSVC */
Index: code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 1627)
+++ code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 1628)
@@ -119,11 +119,4 @@
 
             this->changedVisibility();
-
-            this->setSize(Vector2(0.5f, 0.5f));
-            this->setPickPoint(Vector2(0.5f, 0.5f));
-            this->setPosition(Vector2(0.5f, 0.5f));
-            this->setRotation(Degree(0.0f));
-            this->setAspectCorrection(true);
-            this->setBackgroundMaterial("");
         }
 
Index: code/trunk/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OverlayGroup.cc	(revision 1627)
+++ code/trunk/src/orxonox/overlays/OverlayGroup.cc	(revision 1628)
@@ -63,10 +63,4 @@
     {
         BaseObject::XMLPort(xmlElement, mode);
-
-        if (mode == XMLPort::LoadObject)
-        {
-            this->setScale(Vector2(1.0f, 1.0f));
-            this->setScroll(Vector2(0.0f, 0.0f));
-        }
 
         XMLPortParam(OverlayGroup, "scale",  setScale,  getScale,  xmlElement, mode).defaultValues(Vector2(1.0, 1.0));
Index: code/trunk/src/orxonox/overlays/OverlayText.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OverlayText.cc	(revision 1627)
+++ code/trunk/src/orxonox/overlays/OverlayText.cc	(revision 1628)
@@ -65,8 +65,4 @@
 
             this->background_->addChild(this->text_);
-
-            this->setFont("Monofur");
-            this->caption_ = "";
-            this->setTextSize(1.0f);
         }
 
Index: code/trunk/src/orxonox/overlays/hud/HUDBar.cc
===================================================================
--- code/trunk/src/orxonox/overlays/hud/HUDBar.cc	(revision 1627)
+++ code/trunk/src/orxonox/overlays/hud/HUDBar.cc	(revision 1628)
@@ -55,10 +55,4 @@
         BaseObject::XMLPort(xmlElement, mode);
 
-        if (mode == XMLPort::LoadObject)
-        {
-            this->setColour(ColourValue(1.0, 1.0, 1.0, 1.0));
-            this->setPosition(0.0f);
-        }
-
         XMLPortParam(BarColour, "colour", setColour, getColour, xmlElement, mode)
             .defaultValues(ColourValue(1.0, 1.0, 1.0, 1.0));
@@ -101,12 +95,8 @@
             this->bar_->setMaterialName(materialname);
             this->background_->addChild(bar_);
-
-            this->setValue(0.0f);
-            this->setRightToLeft(false);
-            this->setAutoColour(true);
         }
 
-        XMLPortParam(HUDBar, "initialValue", setValue,       getValue,       xmlElement, mode).defaultValues(0.0f);
-        XMLPortParam(HUDBar, "rightToLeft",   setRightToLeft, getRightToLeft, xmlElement, mode).defaultValues(false);
+        XMLPortParam(HUDBar, "initialValue", setValue,       getValue,       xmlElement, mode).defaultValues(0.4567654f);
+        XMLPortParam(HUDBar, "rightToLeft",  setRightToLeft, getRightToLeft, xmlElement, mode).defaultValues(false);
         XMLPortParam(HUDBar, "autoColour",   setAutoColour,  getAutoColour,  xmlElement, mode).defaultValues(true);
         XMLPortObject(HUDBar, BarColour, "", addColour, getColour, xmlElement, mode, false, true);
Index: code/trunk/src/orxonox/overlays/hud/HUDNavigation.cc
===================================================================
--- code/trunk/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 1627)
+++ code/trunk/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 1628)
@@ -94,9 +94,4 @@
             // hide at first
             this->setVisible(false);
-
-            this->setFont("Monofur");
-            this->setTextSize(0.05f);
-            this->setNavMarkerSize(0.05f);
-            this->setAimMarkerSize(0.04f);
         }
 
Index: code/trunk/src/orxonox/overlays/hud/HUDRadar.cc
===================================================================
--- code/trunk/src/orxonox/overlays/hud/HUDRadar.cc	(revision 1627)
+++ code/trunk/src/orxonox/overlays/hud/HUDRadar.cc	(revision 1628)
@@ -75,8 +75,4 @@
             overlay_->add2D(marker_);
             marker_->hide();
-
-            this->setRadarSensitivity(1.0f);
-            this->setHalfDotSizeDistance(3000.0f);
-            this->setMaximumDotSize(0.1f);
         }
 